C
C  ---------------------------------------------------------------------
C
      FUNCTION FUNMIN ( X, N )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
      COMMON / TOMS / IFUNI
C
C  THIS IS AN EMPTY FUNMIN, SINCE ALL TEST PROBLEMS INCLUDED
C  IN THIS FILE ARE SUM-OF-SQUARES FUNCTIONS.
C
      FUNMIN = 0
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SUBSUM ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      COMMON / TOMS / IFUNI
C
      IF (IFUNI.EQ.1) THEN
C  ROSENBROCK
         CALL FROSE(M,N,X,F)
      ELSE IF (IFUNI.EQ.2) THEN
C  FREUDENSTEIN & ROTH
         CALL FFROTH(M,N,X,F)
      ELSE IF (IFUNI.EQ.3) THEN
C  POWELL BADLY SCALED
         CALL FPBS(M,N,X,F)
      ELSE IF (IFUNI.EQ.4) THEN
C  BROWN BADLY SCALED
         CALL FBBS(M,N,X,F)
      ELSE IF (IFUNI.EQ.5) THEN
C  BEALE
         CALL FBEALE(M,N,X,F)
      ELSE IF (IFUNI.EQ.6) THEN
C  JENNRICH & SAMPSON
         CALL FJESAM(M,N,X,F)
      ELSE IF (IFUNI.EQ.7) THEN
C  HELICAL VALEY
         CALL FHELIX(M,N,X,F)
      ELSE IF (IFUNI.EQ.8) THEN
C  BARD
         CALL FBARD(M,N,X,F)
      ELSE IF (IFUNI.EQ.9) THEN
C  GAUSSIAN
         CALL FGAUSS(M,N,X,F)
      ELSE IF (IFUNI.EQ.10) THEN
C  MEYER
         CALL FMEYER(M,N,X,F)
      ELSE IF (IFUNI.EQ.11) THEN
C  GULF
         CALL FGULF(M,N,X,F)
      ELSE IF (IFUNI.EQ.12) THEN
C  BOX 3-D
         CALL FBOX(M,N,X,F)
      ELSE IF (IFUNI.EQ.13) THEN
C  POWELL SINGULAR
         CALL FPSING(M,N,X,F)
      ELSE IF (IFUNI.EQ.14) THEN
C  WOOD
         CALL FWOOD(M,N,X,F)
      ELSE IF (IFUNI.EQ.15) THEN
C  KOWALIK AND OSBORNE
         CALL FKOWOS(M,N,X,F)
      ELSE IF (IFUNI.EQ.16) THEN
C  BROWN AND DENNIS
         CALL FBRDEN(M,N,X,F)
      ELSE IF (IFUNI.EQ.17) THEN
C  OSBORNE 1
         CALL FOSB1(M,N,X,F)
      ELSE IF (IFUNI.EQ.18) THEN
C  BIGGS EXP6
         CALL FBIGGS(M,N,X,F)
      ELSE IF (IFUNI.EQ.19) THEN
C  OSBORNE 2
         CALL FOSB2(M,N,X,F)
      ELSE IF (IFUNI.EQ.20) THEN
C  WATSON
         CALL FWATSO(M,N,X,F)
      ELSE IF (IFUNI.EQ.21) THEN
C  EXTENDED ROSENBROCK
         CALL FROSEX(M,N,X,F)
      ELSE IF (IFUNI.EQ.22) THEN
C  EXTENDED POWELL SINGULAR
         CALL FPSINX(M,N,X,F)
      ELSE IF (IFUNI.EQ.23) THEN
C  PENALTY I
         CALL FPEN1(M,N,X,F)
      ELSE IF (IFUNI.EQ.24) THEN
C  PENALTY II
         CALL FPEN2(M,N,X,F)
      ELSE IF (IFUNI.EQ.25) THEN
C  VARIABLY DIMENSIONED
         CALL FVARDI(M,N,X,F)
      ELSE IF (IFUNI.EQ.26) THEN
C  TRIGONOMETRIC
         CALL FTRIG(M,N,X,F)
      ELSE IF (IFUNI.EQ.27) THEN
C  BROWN ALMOST LINEAR
         CALL FBALMO(M,N,X,F)
      ELSE IF (IFUNI.EQ.28) THEN
C  DISCRETE BOUNDARY PROBLEM
         CALL FDBP(M,N,X,F)
      ELSE IF (IFUNI.EQ.29) THEN
C  DISCRETE INTEGRAL EQUATION
         CALL FDIE(M,N,X,F)
      ELSE IF (IFUNI.EQ.30) THEN
C  BROYDEN TRIDIAGONAL
         CALL FBTRI(M,N,X,F)
      ELSE IF (IFUNI.EQ.31) THEN
C  BROYDEN BANDED
         CALL FBBAND(M,N,X,F)
      ELSE IF (IFUNI.EQ.32) THEN
C  LINEAR, FULL RANK
         CALL FLINE(M,N,X,F)
      ELSE IF (IFUNI.EQ.33) THEN
C  LINEAR, RANK 1
         CALL FLINE1(M,N,X,F)
      ELSE IF (IFUNI.EQ.34) THEN
C  LINEAR, RANK1 WITH ZERO COLUMNS AND ROWS
         CALL FLINE0(M,N,X,F)
      ELSE IF (IFUNI.EQ.35) THEN
C  CHEBYQUAD
         CALL FCHEBY(M,N,X,F)
      ELSE
         WRITE (*,*) 'ERROR: THERE IS NO SUCH PROBLEM NUMBER: ',IFUNI
         STOP 'ERR'
      ENDIF
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE GRANAL ( N, X, VAL, GRAD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), GRAD(N)
C
      COMMON/PARAMX/NOF
      COMMON / TOMS / IFUNI

      DIMENSION FJ(65,20), F(65)
C
      M = NOF
      LD = 65
      IF (IFUNI.EQ.1) THEN
C  ROSENBROCK
         CALL JROSE(M,N,X,FJ,LD)
         CALL FROSE(M,N,X,F)
         CALL JFPROD(M,N,FJ,LD,F,GRAD)
      ELSE IF (IFUNI.EQ.2) THEN
C  FREUDENSTEIN & ROTH
         CALL JFROTH(M,N,X,FJ,LD)
         CALL FFROTH(M,N,X,F)
         CALL JFPROD(M,N,FJ,LD,F,GRAD)
      ELSE IF (IFUNI.EQ.3) THEN
C  POWELL BADLY SCALED
         CALL JPBS(M,N,X,FJ,LD)
         CALL FPBS(M,N,X,F)
         CALL JFPROD(M,N,FJ,LD,F,GRAD)
      ELSE IF (IFUNI.EQ.4) THEN
C  BROWN BADLY SCALED
         CALL JBBS(M,N,X,FJ,LD)
         CALL FBBS(M,N,X,F)
         CALL JFPROD(M,N,FJ,LD,F,GRAD)
      ELSE IF (IFUNI.EQ.5) THEN
C  BEALE
         CALL JBEALE(M,N,X,FJ,LD)
         CALL FBEALE(M,N,X,F)
         CALL JFPROD(M,N,FJ,LD,F,GRAD)
      ELSE IF (IFUNI.EQ.6) THEN
C  JENNRICH & SAMPSON
         CALL JJESAM(M,N,X,FJ,LD)
         CALL FJESAM(M,N,X,F)
         CALL JFPROD(M,N,FJ,LD,F,GRAD)
      ELSE IF (IFUNI.EQ.7) THEN
C  HELICAL VALEY
         CALL JHELIX(M,N,X,FJ,LD)
         CALL FHELIX(M,N,X,F)
         CALL JFPROD(M,N,FJ,LD,F,GRAD)
      ELSE IF (IFUNI.EQ.8) THEN
C  BARD
         CALL JBARD(M,N,X,FJ,LD)
         CALL FBARD(M,N,X,F)
         CALL JFPROD(M,N,FJ,LD,F,GRAD)
      ELSE IF (IFUNI.EQ.9) THEN
C  GAUSSIAN
         CALL JGAUSS(M,N,X,FJ,LD)
         CALL FGAUSS(M,N,X,F)
         CALL JFPROD(M,N,FJ,LD,F,GRAD)
      ELSE IF (IFUNI.EQ.10) THEN
C  MEYER
         CALL JMEYER(M,N,X,FJ,LD)
         CALL FMEYER(M,N,X,F)
         CALL JFPROD(M,N,FJ,LD,F,GRAD)
      ELSE IF (IFUNI.EQ.11) THEN
C  GULF
         CALL JGULF(M,N,X,FJ,LD)
         CALL FGULF(M,N,X,F)
         CALL JFPROD(M,N,FJ,LD,F,GRAD)
      ELSE IF (IFUNI.EQ.12) THEN
C  BOX 3-D
         CALL JBOX(M,N,X,FJ,LD)
         CALL FBOX(M,N,X,F)
         CALL JFPROD(M,N,FJ,LD,F,GRAD)
      ELSE IF (IFUNI.EQ.13) THEN
C  POWELL SINGULAR
         CALL JPSING(M,N,X,FJ,LD)
         CALL FPSING(M,N,X,F)
         CALL JFPROD(M,N,FJ,LD,F,GRAD)
      ELSE IF (IFUNI.EQ.14) THEN
C  WOOD
         CALL JWOOD(M,N,X,FJ,LD)
         CALL FWOOD(M,N,X,F)
         CALL JFPROD(M,N,FJ,LD,F,GRAD)
      ELSE IF (IFUNI.EQ.15) THEN
C  KOWALIK AND OSBORNE
         CALL JKOWOS(M,N,X,FJ,LD)
         CALL FKOWOS(M,N,X,F)
         CALL JFPROD(M,N,FJ,LD,F,GRAD)
      ELSE IF (IFUNI.EQ.16) THEN
C  BROWN AND DENNIS
         CALL JBRDEN(M,N,X,FJ,LD)
         CALL FBRDEN(M,N,X,F)
         CALL JFPROD(M,N,FJ,LD,F,GRAD)
      ELSE IF (IFUNI.EQ.17) THEN
C  OSBORNE 1
         CALL JOSB1(M,N,X,FJ,LD)
         CALL FOSB1(M,N,X,F)
         CALL JFPROD(M,N,FJ,LD,F,GRAD)
      ELSE IF (IFUNI.EQ.18) THEN
C  BIGGS EXP6
         CALL JBIGGS(M,N,X,FJ,LD)
         CALL FBIGGS(M,N,X,F)
         CALL JFPROD(M,N,FJ,LD,F,GRAD)
      ELSE IF (IFUNI.EQ.19) THEN
C  OSBORNE 2
         CALL JOSB2(M,N,X,FJ,LD)
         CALL FOSB2(M,N,X,F)
         CALL JFPROD(M,N,FJ,LD,F,GRAD)
      ELSE IF (IFUNI.EQ.20) THEN
C  WATSON
         CALL JWATSO(M,N,X,FJ,LD)
         CALL FWATSO(M,N,X,F)
         CALL JFPROD(M,N,FJ,LD,F,GRAD)
      ELSE IF (IFUNI.EQ.21) THEN
C  EXTENDED ROSENBROCK
         CALL JROSEX(M,N,X,FJ,LD)
         CALL FROSEX(M,N,X,F)
         CALL JFPROD(M,N,FJ,LD,F,GRAD)
      ELSE IF (IFUNI.EQ.22) THEN
C  EXTENDED POWELL SINGULAR
         CALL JPSINX(M,N,X,FJ,LD)
         CALL FPSINX(M,N,X,F)
         CALL JFPROD(M,N,FJ,LD,F,GRAD)
      ELSE IF (IFUNI.EQ.23) THEN
C  PENALTY I
         CALL JPEN1(M,N,X,FJ,LD)
         CALL FPEN1(M,N,X,F)
         CALL JFPROD(M,N,FJ,LD,F,GRAD)
      ELSE IF (IFUNI.EQ.24) THEN
C  PENALTY II
         CALL JPEN2(M,N,X,FJ,LD)
         CALL FPEN2(M,N,X,F)
         CALL JFPROD(M,N,FJ,LD,F,GRAD)
      ELSE IF (IFUNI.EQ.25) THEN
C  VARIABLY DIMENSIONED
         CALL JVARDI(M,N,X,FJ,LD)
         CALL FVARDI(M,N,X,F)
         CALL JFPROD(M,N,FJ,LD,F,GRAD)
      ELSE IF (IFUNI.EQ.26) THEN
C  TRIGONOMETRIC
         CALL JTRIG(M,N,X,FJ,LD)
         CALL FTRIG(M,N,X,F)
         CALL JFPROD(M,N,FJ,LD,F,GRAD)
      ELSE IF (IFUNI.EQ.27) THEN
C  BROWN ALMOST LINEAR
         CALL JBALMO(M,N,X,FJ,LD)
         CALL FBALMO(M,N,X,F)
         CALL JFPROD(M,N,FJ,LD,F,GRAD)
      ELSE IF (IFUNI.EQ.28) THEN
C  DISCRETE BOUNDARY PROBLEM
         CALL JDBP(M,N,X,FJ,LD)
         CALL FDBP(M,N,X,F)
         CALL JFPROD(M,N,FJ,LD,F,GRAD)
      ELSE IF (IFUNI.EQ.29) THEN
C  DISCRETE INTEGRAL EQUATION
         CALL JDIE(M,N,X,FJ,LD)
         CALL FDIE(M,N,X,F)
         CALL JFPROD(M,N,FJ,LD,F,GRAD)
      ELSE IF (IFUNI.EQ.30) THEN
C  BROYDEN TRIDIAGONAL
         CALL JBTRI(M,N,X,FJ,LD)
         CALL FBTRI(M,N,X,F)
         CALL JFPROD(M,N,FJ,LD,F,GRAD)
      ELSE IF (IFUNI.EQ.31) THEN
C  BROYDEN BANDED
         CALL JBBAND(M,N,X,FJ,LD)
         CALL FBBAND(M,N,X,F)
         CALL JFPROD(M,N,FJ,LD,F,GRAD)
      ELSE IF (IFUNI.EQ.32) THEN
C  LINEAR, FULL RANK
         CALL JLINE(M,N,X,FJ,LD)
         CALL FLINE(M,N,X,F)
         CALL JFPROD(M,N,FJ,LD,F,GRAD)
      ELSE IF (IFUNI.EQ.33) THEN
C  LINEAR, RANK 1
         CALL JLINE1(M,N,X,FJ,LD)
         CALL FLINE1(M,N,X,F)
         CALL JFPROD(M,N,FJ,LD,F,GRAD)
      ELSE IF (IFUNI.EQ.34) THEN
C  LINEAR, RANK1 WITH ZERO COLUMNS AND ROWS
         CALL JLINE0(M,N,X,FJ,LD)
         CALL FLINE0(M,N,X,F)
         CALL JFPROD(M,N,FJ,LD,F,GRAD)
      ELSE IF (IFUNI.EQ.35) THEN
C  CHEBYQUAD
         CALL JCHEBY(M,N,X,FJ,LD)
         CALL FCHEBY(M,N,X,F)
         CALL JFPROD(M,N,FJ,LD,F,GRAD)
      ELSE
         WRITE (*,*) 'ERROR: THERE IS NO SUCH PROBLEM NUMBER: ',IFUNI
         STOP 'ERR'
      ENDIF
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JFPROD ( M, N, FJ, LD, F, G )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION FJ(LD,N), F(M), G(N)
C
      DO 20,I=1,N
         SUM = 0
         DO 30,J=1,M
30       SUM = SUM+FJ(J,I)*F(J)
         G(I) = 2*SUM
20    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      BLOCK DATA FUDATA 
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      COMMON / TOMS / IFUNI
      DATA IFUNI / 0 /
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FUSELE ( I )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C  SELECTS A TEST PROBLEM BY SETTING THE APPROPRIATE VALUE
C  IN COMMON BL0CK / TOMS /
C
      PARAMETER ( MXV = 200 )
      PARAMETER ( NPROBS = 35 )
      COMMON / TOMS / IFUNI
      CHARACTER*20 NAME
      DIMENSION XSOL(MXV)
C
      IF (I.GE.1 .AND. I.LE.NPROBS) THEN
         IFUNI = I
      ELSE
         WRITE (*,*) 'ERROR: THERE IS NO SUCH PROBLEM NUMBER: ',I
         WRITE (*,*) 'PROBLEMS ARE:'
         WRITE (*,'(65(''-''))') 
         DO 10,I=1,NPROBS
            IFUNI = I
            CALL FUNAME(NAME)
         CALL FUDIM(N,M)
         CALL FUSOL(N,M,XSOL,FTF,IX,IV,IM)
         IF (IV.EQ.1) THEN
            WRITE (*,20) I, NAME, N, M, FTF
         ELSE
            WRITE (*,30) I, NAME, N, M
         END IF
10       CONTINUE
         STOP
      END IF
20    FORMAT (T2,I2,3X,A,3X,'N= ',I2,3X,'M= ',I2,3X,'F*= ',1PG13.6)
30    FORMAT (T2,I2,3X,A,3X,'N= ',I2,3X,'M= ',I2)
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FUNAME ( NAME )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      CHARACTER*(*) NAME
      COMMON / TOMS / IFUNI
C
      IF (IFUNI.EQ.1) THEN
         NAME = 'ROSENBROCK'
      ELSE IF (IFUNI.EQ.2) THEN
         NAME = 'FREUDENSTEIN & ROTH'
      ELSE IF (IFUNI.EQ.3) THEN
         NAME = 'POWELL BADLY SCALED'
      ELSE IF (IFUNI.EQ.4) THEN
         NAME = 'BROWN BADLY SCALED'
      ELSE IF (IFUNI.EQ.5) THEN
         NAME = 'BEALE'
      ELSE IF (IFUNI.EQ.6) THEN
         NAME = 'JENNRICH & SAMPSON'
      ELSE IF (IFUNI.EQ.7) THEN
         NAME = 'HELICAL VALEY'
      ELSE IF (IFUNI.EQ.8) THEN
         NAME = 'BARD'
      ELSE IF (IFUNI.EQ.9) THEN
         NAME = 'GAUSSIAN'
      ELSE IF (IFUNI.EQ.10) THEN
         NAME = 'MEYER'
      ELSE IF (IFUNI.EQ.11) THEN
         NAME = 'GULF'
      ELSE IF (IFUNI.EQ.12) THEN
         NAME = 'BOX 3-D'
      ELSE IF (IFUNI.EQ.13) THEN
         NAME = 'POWELL SINGULAR'
      ELSE IF (IFUNI.EQ.14) THEN
         NAME = 'WOOD'
      ELSE IF (IFUNI.EQ.15) THEN
         NAME = 'KOWALIK AND OSBORNE'
      ELSE IF (IFUNI.EQ.16) THEN
         NAME = 'BROWN AND DENNIS'
      ELSE IF (IFUNI.EQ.17) THEN
         NAME = 'OSBORNE 1'
      ELSE IF (IFUNI.EQ.18) THEN
         NAME = 'BIGGS EXP6'
      ELSE IF (IFUNI.EQ.19) THEN
         NAME = 'OSBORNE 2'
      ELSE IF (IFUNI.EQ.20) THEN
         NAME = 'WATSON'
      ELSE IF (IFUNI.EQ.21) THEN
         NAME = 'EXTENDED ROSENBROCK'
      ELSE IF (IFUNI.EQ.22) THEN
         NAME = 'EXTENDED POWELL SINGULAR'
      ELSE IF (IFUNI.EQ.23) THEN
         NAME = 'PENALTY I'
      ELSE IF (IFUNI.EQ.24) THEN
         NAME = 'PENALTY II'
      ELSE IF (IFUNI.EQ.25) THEN
         NAME = 'VARIABLY DIMENSIONED'
      ELSE IF (IFUNI.EQ.26) THEN
         NAME = 'TRIGONOMETRIC'
      ELSE IF (IFUNI.EQ.27) THEN
         NAME = 'BROWN ALMOST LINEAR'
      ELSE IF (IFUNI.EQ.28) THEN
         NAME = 'DISCRETE BOUNDARY PR'
      ELSE IF (IFUNI.EQ.29) THEN
         NAME = 'DISCRETE INTEGRAL EQ'
      ELSE IF (IFUNI.EQ.30) THEN
         NAME = 'BROYDEN TRIDIAGONAL'
      ELSE IF (IFUNI.EQ.31) THEN
         NAME = 'BROYDEN BANDED'
      ELSE IF (IFUNI.EQ.32) THEN
         NAME = 'LINEAR, FULL RANK'
      ELSE IF (IFUNI.EQ.33) THEN
         NAME = 'LINEAR, RANK 1'
      ELSE IF (IFUNI.EQ.34) THEN
         NAME = 'LINEAR, RANK1, ZERO'
      ELSE IF (IFUNI.EQ.35) THEN
         NAME = 'CHEBYQUAD'
      ELSE
         WRITE (*,*) 'ERROR: THERE IS NO SUCH PROBLEM NUMBER: ',IFUNI
         STOP 'ERR'
      ENDIF
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FUDIM ( N, M )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C  RETURNS THE NUMBER OF VARIABLES AND NUMBER OF TERMS
C  IN THE SUM OF SQUARES CASE, FOR THE SELECTED PROBLEM.
C
      COMMON / TOMS / IFUNI
C
      IF (IFUNI.EQ.1) THEN
C  ROSENBROCK
         N = 2
         M = 2
      ELSE IF (IFUNI.EQ.2) THEN
C  FREUDENSTEIN & ROTH
         N = 2
         M = 2
      ELSE IF (IFUNI.EQ.3) THEN
C  POWELL BADLY SCALED
         N = 2
         M = 2
      ELSE IF (IFUNI.EQ.4) THEN
C  BROWN BADLY SCALED
         N = 2
         M = 3
      ELSE IF (IFUNI.EQ.5) THEN
C  BEALE
         N = 2
         M = 3
      ELSE IF (IFUNI.EQ.6) THEN
C  JENNRICH & SAMPSON
         N = 2
         M = 10
      ELSE IF (IFUNI.EQ.7) THEN
C  HELICAL VALEY
         N = 3
         M = 3
      ELSE IF (IFUNI.EQ.8) THEN
C  BARD
         N = 3
         M = 15
      ELSE IF (IFUNI.EQ.9) THEN
C  GAUSSIAN
         N = 3
         M = 15
      ELSE IF (IFUNI.EQ.10) THEN
C  MEYER
         N = 3
         M = 16
      ELSE IF (IFUNI.EQ.11) THEN
C  GULF
         N = 3
         M = 10
      ELSE IF (IFUNI.EQ.12) THEN
C  BOX 3-D
         N = 3
         M = 10
      ELSE IF (IFUNI.EQ.13) THEN
C  POWELL SINGULAR
         N = 4
         M = 4
      ELSE IF (IFUNI.EQ.14) THEN
C  WOOD
         N = 4
         M = 6
      ELSE IF (IFUNI.EQ.15) THEN
C  KOWALIK AND OSBORNE
         N = 4
         M = 11
      ELSE IF (IFUNI.EQ.16) THEN
C  BROWN AND DENNIS
         N = 4
         M = 20
      ELSE IF (IFUNI.EQ.17) THEN
C  OSBORNE 1
         N = 5
         M = 33
      ELSE IF (IFUNI.EQ.18) THEN
C  BIGGS EXP6
         N = 6
         M = 13
      ELSE IF (IFUNI.EQ.19) THEN
C  OSBORNE 2
         N = 11
         M = 65
      ELSE IF (IFUNI.EQ.20) THEN
C  WATSON
         N = 20
         M = 31
      ELSE IF (IFUNI.EQ.21) THEN
C  EXTENDED ROSENBROCK
         N = 10
         M = 10
      ELSE IF (IFUNI.EQ.22) THEN
C  EXTENDED POWELL SINGULAR
         N = 12
         M = 12
      ELSE IF (IFUNI.EQ.23) THEN
C  PENALTY I
         N = 4
         M = 5
      ELSE IF (IFUNI.EQ.24) THEN
C  PENALTY II
         N = 4
         M = 8
      ELSE IF (IFUNI.EQ.25) THEN
C  VARIABLY DIMENSIONED
         N = 10
         M = 12
      ELSE IF (IFUNI.EQ.26) THEN
C  TRIGONOMETRIC
         N = 10
         M = 10
      ELSE IF (IFUNI.EQ.27) THEN
C  BROWN ALMOST LINEAR
         N = 10
         M = 10
      ELSE IF (IFUNI.EQ.28) THEN
C  DISCRETE BOUNDARY PROBLEM
         N = 10
         M = 10
      ELSE IF (IFUNI.EQ.29) THEN
C  DISCRETE INTEGRAL EQUATION
         N = 10
         M = 10
      ELSE IF (IFUNI.EQ.30) THEN
C  BROYDEN TRIDIAGONAL
         N = 10
         M = 10
      ELSE IF (IFUNI.EQ.31) THEN
C  BROYDEN BANDED
         N = 10
         M = 10
      ELSE IF (IFUNI.EQ.32) THEN
C  LINEAR, FULL RANK
         N = 10
         M = 20
      ELSE IF (IFUNI.EQ.33) THEN
C  LINEAR, RANK 1
         N = 10
         M = 20
      ELSE IF (IFUNI.EQ.34) THEN
C  LINEAR, RANK1 WITH ZERO COLUMNS AND ROWS
         N = 10
         M = 20
      ELSE IF (IFUNI.EQ.35) THEN
C  CHEBYQUAD
         N = 10
         M = 10
      ELSE
         WRITE (*,*) 'ERROR: THERE IS NO SUCH PROBLEM NUMBER: ',IFUNI
         STOP 'ERR'
      ENDIF
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FUSOL ( N, M, X, FTF, IX, IV, IM )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C  RETURNS THE SOLUTION VECTOR AND THE CORRESPONDING OBJECTIVE FUNCTION
C  VALUE FOR THE SELECTED PROBLEM.
C  IX = 1,0 IF THE SOLUTION VECTOR IS / IS NOT KNOWN.
C  IF = 1,0 IF THE FUNCTION VALUE AT THE SOLUTION IS / IS NOT KNOWN.
C  IM = 1,0 IF MORE THAN 1 MINIMUM IS KNOWN.
C
      COMMON / TOMS / IFUNI
      DIMENSION X(N)
C
      IF (IFUNI.EQ.1) THEN
C  ROSENBROCK
         CALL SROSE(N,M,X,FTF)
      ELSE IF (IFUNI.EQ.2) THEN
C  FREUDENSTEIN & ROTH
         CALL SFROTH(N,M,X,FTF)
      ELSE IF (IFUNI.EQ.3) THEN
C  POWELL BADLY SCALED
         CALL SPBS(N,M,X,FTF)
      ELSE IF (IFUNI.EQ.4) THEN
C  BROWN BADLY SCALED
         CALL SBBS(N,M,X,FTF)
      ELSE IF (IFUNI.EQ.5) THEN
C  BEALE
         CALL SBEALE(N,M,X,FTF)
      ELSE IF (IFUNI.EQ.6) THEN
C  JENNRICH & SAMPSON
         CALL SJESAM(N,M,X,FTF)
      ELSE IF (IFUNI.EQ.7) THEN
C  HELICAL VALEY
         CALL SHELIX(N,M,X,FTF)
      ELSE IF (IFUNI.EQ.8) THEN
C  BARD
         CALL SBARD(N,M,X,FTF)
      ELSE IF (IFUNI.EQ.9) THEN
C  GAUSSIAN
         CALL SGAUSS(N,M,X,FTF)
      ELSE IF (IFUNI.EQ.10) THEN
C  MEYER
         CALL SMEYER(N,M,X,FTF)
      ELSE IF (IFUNI.EQ.11) THEN
C  GULF
         CALL SGULF(N,M,X,FTF)
      ELSE IF (IFUNI.EQ.12) THEN
C  BOX 3-D
         CALL SBOX(N,M,X,FTF)
      ELSE IF (IFUNI.EQ.13) THEN
C  POWELL SINGULAR
         CALL SPSING(N,M,X,FTF)
      ELSE IF (IFUNI.EQ.14) THEN
C  WOOD
         CALL SWOOD(N,M,X,FTF)
      ELSE IF (IFUNI.EQ.15) THEN
C  KOWALIK AND OSBORNE
         CALL SKOWOS(N,M,X,FTF)
      ELSE IF (IFUNI.EQ.16) THEN
C  BROWN AND DENNIS
         CALL SBRDEN(N,M,X,FTF)
      ELSE IF (IFUNI.EQ.17) THEN
C  OSBORNE 1
         CALL SOSB1(N,M,X,FTF)
      ELSE IF (IFUNI.EQ.18) THEN
C  BIGGS EXP6
         CALL SBIGGS(N,M,X,FTF)
      ELSE IF (IFUNI.EQ.19) THEN
C  OSBORNE 2
         CALL SOSB2(N,M,X,FTF)
      ELSE IF (IFUNI.EQ.20) THEN
C  WATSON
         CALL SWATSO(N,M,X,FTF)
      ELSE IF (IFUNI.EQ.21) THEN
C  EXTENDED ROSENBROCK
         CALL SROSEX(N,M,X,FTF)
      ELSE IF (IFUNI.EQ.22) THEN
C  EXTENDED POWELL SINGULAR
         CALL SPSINX(N,M,X,FTF)
      ELSE IF (IFUNI.EQ.23) THEN
C  PENALTY I
         CALL SPEN1(N,M,X,FTF)
      ELSE IF (IFUNI.EQ.24) THEN
C  PENALTY II
         CALL SPEN2(N,M,X,FTF)
      ELSE IF (IFUNI.EQ.25) THEN
C  VARIABLY DIMENSIONED
         CALL SVARDI(N,M,X,FTF)
      ELSE IF (IFUNI.EQ.26) THEN
C  TRIGONOMETRIC
         CALL STRIG(N,M,X,FTF)
      ELSE IF (IFUNI.EQ.27) THEN
C  BROWN ALMOST LINEAR
         CALL SBALMO(N,M,X,FTF)
      ELSE IF (IFUNI.EQ.28) THEN
C  DISCRETE BOUNDARY PROBLEM
         CALL SDBP(N,M,X,FTF)
      ELSE IF (IFUNI.EQ.29) THEN
C  DISCRETE INTEGRAL EQUATION
         CALL SDIE(N,M,X,FTF)
      ELSE IF (IFUNI.EQ.30) THEN
C  BROYDEN TRIDIAGONAL
         CALL SBTRI(N,M,X,FTF)
      ELSE IF (IFUNI.EQ.31) THEN
C  BROYDEN BANDED
         CALL SBBAND(N,M,X,FTF)
      ELSE IF (IFUNI.EQ.32) THEN
C  LINEAR, FULL RANK
         CALL SLINE(N,M,X,FTF)
      ELSE IF (IFUNI.EQ.33) THEN
C  LINEAR, RANK 1
         CALL SLINE1(N,M,X,FTF)
      ELSE IF (IFUNI.EQ.34) THEN
C  LINEAR, RANK1 WITH ZERO COLUMNS AND ROWS
         CALL SLINE0(N,M,X,FTF)
      ELSE IF (IFUNI.EQ.35) THEN
C  CHEBYQUAD
         CALL SCHEBY(N,M,X,FTF)
      ELSE
         WRITE (*,*) 'ERROR: THERE IS NO SUCH PROBLEM NUMBER: ',IFUNI
         STOP 'ERR'
      ENDIF
C
      CALL FUKNOW(IX,IV,IM)
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FUIPT ( N, M, X, FACTOR )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
C  RETURNS THE STANDARD STARTING POINT FOR THE SELECTED PROBLEM,
C  MULTIPLIED BY THE INPUT FACTOR PARAMETER.
C  SEE MORE ET AL. FOR DETAILS.
C
      DIMENSION X(N)
      COMMON / TOMS / IFUNI
C
      IF (IFUNI.EQ.1) THEN
C  ROSENBROCK
         CALL IROSE(N,M,X)
      ELSE IF (IFUNI.EQ.2) THEN
C  FREUDENSTEIN & ROTH
         CALL IFROTH(N,M,X)
      ELSE IF (IFUNI.EQ.3) THEN
C  POWELL BADLY SCALED
         CALL IPBS(N,M,X)
      ELSE IF (IFUNI.EQ.4) THEN
C  BROWN BADLY SCALED
         CALL IBBS(N,M,X)
      ELSE IF (IFUNI.EQ.5) THEN
C  BEALE
         CALL IBEALE(N,M,X)
      ELSE IF (IFUNI.EQ.6) THEN
C  JENNRICH & SAMPSON
         CALL IJESAM(N,M,X)
      ELSE IF (IFUNI.EQ.7) THEN
C  HELICAL VALEY
         CALL IHELIX(N,M,X)
      ELSE IF (IFUNI.EQ.8) THEN
C  BARD
         CALL IBARD(N,M,X)
      ELSE IF (IFUNI.EQ.9) THEN
C  GAUSSIAN
         CALL IGAUSS(N,M,X)
      ELSE IF (IFUNI.EQ.10) THEN
C  MEYER
         CALL IMEYER(N,M,X)
      ELSE IF (IFUNI.EQ.11) THEN
C  GULF
         CALL IGULF(N,M,X)
      ELSE IF (IFUNI.EQ.12) THEN
C  BOX 3-D
         CALL IBOX(N,M,X)
      ELSE IF (IFUNI.EQ.13) THEN
C  POWELL SINGULAR
         CALL IPSING(N,M,X)
      ELSE IF (IFUNI.EQ.14) THEN
C  WOOD
         CALL IWOOD(N,M,X)
      ELSE IF (IFUNI.EQ.15) THEN
C  KOWALIK AND OSBORNE
         CALL IKOWOS(N,M,X)
      ELSE IF (IFUNI.EQ.16) THEN
C  BROWN AND DENNIS
         CALL IBRDEN(N,M,X)
      ELSE IF (IFUNI.EQ.17) THEN
C  OSBORNE 1
         CALL IOSB1(N,M,X)
      ELSE IF (IFUNI.EQ.18) THEN
C  BIGGS EXP6
         CALL IBIGGS(N,M,X)
      ELSE IF (IFUNI.EQ.19) THEN
C  OSBORNE 2
         CALL IOSB2(N,M,X)
      ELSE IF (IFUNI.EQ.20) THEN
C  WATSON
         CALL IWATSO(N,M,X)
      ELSE IF (IFUNI.EQ.21) THEN
C  EXTENDED ROSENBROCK
         CALL IROSEX(N,M,X)
      ELSE IF (IFUNI.EQ.22) THEN
C  EXTENDED POWELL SINGULAR
         CALL IPSINX(N,M,X)
      ELSE IF (IFUNI.EQ.23) THEN
C  PENALTY I
         CALL IPEN1(N,M,X)
      ELSE IF (IFUNI.EQ.24) THEN
C  PENALTY II
         CALL IPEN2(N,M,X)
      ELSE IF (IFUNI.EQ.25) THEN
C  VARIABLY DIMENSIONED
         CALL IVARDI(N,M,X)
      ELSE IF (IFUNI.EQ.26) THEN
C  TRIGONOMETRIC
         CALL ITRIG(N,M,X)
      ELSE IF (IFUNI.EQ.27) THEN
C  BROWN ALMOST LINEAR
         CALL IBALMO(N,M,X)
      ELSE IF (IFUNI.EQ.28) THEN
C  DISCRETE BOUNDARY PROBLEM
         CALL IDBP(N,M,X)
      ELSE IF (IFUNI.EQ.29) THEN
C  DISCRETE INTEGRAL EQUATION
         CALL IDIE(N,M,X)
      ELSE IF (IFUNI.EQ.30) THEN
C  BROYDEN TRIDIAGONAL
         CALL IBTRI(N,M,X)
      ELSE IF (IFUNI.EQ.31) THEN
C  BROYDEN BANDED
         CALL IBBAND(N,M,X)
      ELSE IF (IFUNI.EQ.32) THEN
C  LINEAR, FULL RANK
         CALL ILINE(N,M,X)
      ELSE IF (IFUNI.EQ.33) THEN
C  LINEAR, RANK 1
         CALL ILINE1(N,M,X)
      ELSE IF (IFUNI.EQ.34) THEN
C  LINEAR, RANK1 WITH ZERO COLUMNS AND ROWS
         CALL ILINE0(N,M,X)
      ELSE IF (IFUNI.EQ.35) THEN
C  CHEBYQUAD
         CALL ICHEBY(N,M,X)
      ELSE
         WRITE (*,*) 'ERROR: THERE IS NO SUCH PROBLEM NUMBER: ',IFUNI
         STOP 'ERR'
      ENDIF
C
C  IS THE STARTING POINT EQUAL TO THE ZERO VECTOR ?
      SUM = 0.
      DO 10,I=1,N
10       SUM = SUM+ABS(X(I))
      IF (SUM.EQ.0.) THEN
         IF (FACTOR.NE.1.) THEN
            DO 20,I=1,N
20          X(I) = FACTOR
         END IF
      ELSE
         DO 30,I=1,N
30       X(I) = FACTOR*X(I)
      END IF
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FUKNOW ( IX, IV, IM )
C
      COMMON / TOMS / IFUNI
C
      IF (IFUNI.EQ.1) THEN
C  ROSENBROCK
         IX = 1
         IV = 1
         IM = 0
      ELSE IF (IFUNI.EQ.2) THEN
C  FREUDENSTEIN & ROTH
         IX = 1
         IV = 1
         IM = 1
      ELSE IF (IFUNI.EQ.3) THEN
C  POWELL BADLY SCALED
         IX = 1
         IV = 1
         IM = 0
      ELSE IF (IFUNI.EQ.4) THEN
C  BROWN BADLY SCALED
         IX = 1
         IV = 1
         IM = 0
      ELSE IF (IFUNI.EQ.5) THEN
C  BEALE
         IX = 1
         IV = 1
         IM = 0
      ELSE IF (IFUNI.EQ.6) THEN
C  JENNRICH & SAMPSON
         IX = 1
         IV = 1
         IM = 0
      ELSE IF (IFUNI.EQ.7) THEN
C  HELICAL VALEY
         IX = 1
         IV = 1
         IM = 0
      ELSE IF (IFUNI.EQ.8) THEN
C  BARD
         IX = 0
         IV = 1
         IM = 0
      ELSE IF (IFUNI.EQ.9) THEN
C  GAUSSIAN
         IX = 0
         IV = 1
         IM = 0
      ELSE IF (IFUNI.EQ.10) THEN
C  MEYER
         IX = 0
         IV = 1
         IM = 0
      ELSE IF (IFUNI.EQ.11) THEN
C  GULF
         IX = 1
         IV = 1
         IM = 0
      ELSE IF (IFUNI.EQ.12) THEN
C  BOX 3-D
         IX = 1
         IV = 1
         IM = 1
      ELSE IF (IFUNI.EQ.13) THEN
C  POWELL SINGULAR
         IX = 1
         IV = 1
         IM = 0
      ELSE IF (IFUNI.EQ.14) THEN
C  WOOD
         IX = 1
         IV = 1
         IM = 0
      ELSE IF (IFUNI.EQ.15) THEN
C  KOWALIK AND OSBORNE
         IX = 0
         IV = 1
         IM = 1
      ELSE IF (IFUNI.EQ.16) THEN
C  BROWN AND DENNIS
         IX = 0
         IV = 1
         IM = 0
      ELSE IF (IFUNI.EQ.17) THEN
C  OSBORNE 1
         IX = 0
         IV = 1
         IM = 0
      ELSE IF (IFUNI.EQ.18) THEN
C  BIGGS EXP6
         IX = 1
         IV = 1
         IM = 1
      ELSE IF (IFUNI.EQ.19) THEN
C  OSBORNE 2
         IX = 0
         IV = 1
         IM = 0
      ELSE IF (IFUNI.EQ.20) THEN
C  WATSON
         IX = 0
         IV = 0
         IM = 0
      ELSE IF (IFUNI.EQ.21) THEN
C  EXTENDED ROSENBROCK
         IX = 1
         IV = 1
         IM = 0
      ELSE IF (IFUNI.EQ.22) THEN
C  EXTENDED POWELL SINGULAR
         IX = 1
         IV = 1
         IM = 0
      ELSE IF (IFUNI.EQ.23) THEN
C  PENALTY I
         IX = 0
         IV = 1
         IM = 0
      ELSE IF (IFUNI.EQ.24) THEN
C  PENALTY II
         IX = 0
         IV = 1
         IM = 0
      ELSE IF (IFUNI.EQ.25) THEN
C  VARIABLY DIMENSIONED
         IX = 1
         IV = 1
         IM = 0
      ELSE IF (IFUNI.EQ.26) THEN
C  TRIGONOMETRIC
         IX = 0
         IV = 1
         IM = 0
      ELSE IF (IFUNI.EQ.27) THEN
C  BROWN ALMOST LINEAR
         IX = 1
         IV = 1
         IM = 1
      ELSE IF (IFUNI.EQ.28) THEN
C  DISCRETE BOUNDARY PROBLEM
         IX = 0
         IV = 1
         IM = 0
      ELSE IF (IFUNI.EQ.29) THEN
C  DISCRETE INTEGRAL EQUATION
         IX = 0
         IV = 1
         IM = 0
      ELSE IF (IFUNI.EQ.30) THEN
C  BROYDEN TRIDIAGONAL
         IX = 0
         IV = 1
         IM = 0
      ELSE IF (IFUNI.EQ.31) THEN
C  BROYDEN BANDED
         IX = 0
         IV = 1
         IM = 0
      ELSE IF (IFUNI.EQ.32) THEN
C  LINEAR, FULL RANK
         IX = 1
         IV = 1
         IM = 0
      ELSE IF (IFUNI.EQ.33) THEN
C  LINEAR, RANK 1
         IX = 0
         IV = 1
         IM = 1
      ELSE IF (IFUNI.EQ.34) THEN
C  LINEAR, RANK1 WITH ZERO COLUMNS AND ROWS
         IX = 0
         IV = 1
         IM = 1
      ELSE IF (IFUNI.EQ.35) THEN
C  CHEBYQUAD
         IX = 0
         IV = 1
         IM = 0
      ELSE
         WRITE (*,*) 'ERROR: THERE IS NO SUCH PROBLEM NUMBER: ',IFUNI
         STOP 'ERR'
      ENDIF
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FROSE ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      PARAMETER ( COEFF = 10. )
C
      NEVEN = N/2
      DO 10,I=1,NEVEN
         I2 = 2*I
         I1 = I2-1
         X2 = X(I2)
         X1 = X(I1)
         F(I2) = 1.0-X1
         F(I1) = COEFF*(X2-X1*X1)
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JROSE ( M, N, X, FJ, LD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), FJ(LD,N)
C
      PARAMETER ( COEFF = 10. )
C
      NEVEN = N/2
      DO 20,I=1,N
         DO 20,J=1,M
20       FJ(J,I) = 0
C
      DO 10,I=1,NEVEN
         I2 = 2*I
         I1 = I2-1
         X2 = X(I2)
         X1 = X(I1)
         FJ(I1,I1) = -2*COEFF*X1
         FJ(I1,I2) = COEFF
         FJ(I2,I1) = -1
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SROSE ( N, M, X, FTF )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      DO 30,I=1,N
         X(I) = 1
30    CONTINUE
      FTF = 0
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE IROSE ( N, M, X )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      NEVEN = N/2
      DO 21,I=1,NEVEN
         I2 = 2*I
         X(I2-1) = -1.2
         X(I2) = 1.0
21    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FFROTH ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      X1 = X(1)
      X2 = X(2)
      F(1) = -13+X1+((5-X2)*X2-2)*X2
      F(2) = -29+X1+((X2+1)*X2-14)*X2
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JFROTH ( M, N, X, FJ, LD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), FJ(LD,N)
C
      X1 = X(1)
      X2 = X(2)
      FJ(1,1) = 1
      FJ(2,1) = 1
      FJ(1,2) = (10-3*X2)*X2-2
      FJ(2,2) = (3*X2+2)*X2-14
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SFROTH ( N, M, X, FTF )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      X(1) = 5
      X(2) = 4
      FTF = 0
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE IFROTH ( N, M, X )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      X(1) = 0.5
      X(2) = -2
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FPBS ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      X1 = X(1)
      X2 = X(2)
      E1 = EXP(-X1)
      E2 = EXP(-X2)
      F(1) =  10000.*X1*X2-1
      F(2) =  E1+E2-1.0001
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JPBS ( M, N, X, FJ, LD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), FJ(LD,N)
C
      X1 = X(1)
      X2 = X(2)
      E1 = EXP(-X1)
      E2 = EXP(-X2)
      FJ(1,1) = 10000.*X2
      FJ(2,1) = -E1
      FJ(1,2) = 10000.*X1
      FJ(2,2) = -E2
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SPBS ( N, M, X, FTF )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
C  THE FOLLOWING APPROXIMATE VALUES WERE SUPPLIED BY 
C  MORE ET AL.
C     X(1) =  1.098E-5
C     X(2) =  9.106
C
C  FURTHER MINIMIZATION REVEALS:
C
      X(1) = 1.098159E-5
      X(2) = 9.106147
      FTF = 0
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE IPBS ( N, M, X )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      X(1) = 0
      X(2) = 1
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FBBS ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      X1 = X(1)
      X2 = X(2)
      F(1) = X1-1.E6
      F(2) = X2-2.E-6
      F(3) = X1*X2-2
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JBBS ( M, N, X, FJ, LD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), FJ(LD,N)
C
      X1 = X(1)
      X2 = X(2)
C
      FJ(1,1) = 1
      FJ(1,2) = 0
      FJ(2,1) = 1
      FJ(2,2) = 1
      FJ(3,1) = X2
      FJ(3,2) = X1
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SBBS ( N, M, X, FTF )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      X(1) =  1.E6
      X(2) =  2.E-6
      FTF = 0
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE IBBS ( N, M, X )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      X(1) =  1
      X(2) =  1
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FBEALE ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      DIMENSION Y(3)
      DATA Y / 1.5, 2.25, 2.625 /

      X1 = X(1)
      X2 = X(2)
      DO 10,I=1,M
         F(I) = Y(I)-X1*(1-X2**I)
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JBEALE ( M, N, X, FJ, LD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), FJ(LD,N)
C
      X1 = X(1)
      X2 = X(2)
C
      IM1 = 0
      DO 10,I=1,M
         T = X2**IM1
         FJ(I,1) = T*X2-1
         FJ(I,2) = X1*I*T
         IM1 = I
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SBEALE ( N, M, X, FTF )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      X(1) = 3
      X(2) = 0.5
      FTF = 0
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE IBEALE ( N, M, X )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      X(1) = 1
      X(2) = 1
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FJESAM ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      X1 = X(1)
      X2 = X(2)
      DO 10,I=1,M
         F(I) = 2+2*I-(EXP(I*X1)+EXP(I*X2))
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JJESAM ( M, N, X, FJ, LD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), FJ(LD,N)
C
      X1 = X(1)
      X2 = X(2)
C
      DO 10,I=1,M
         FJ(I,1) = -I*(EXP(I*X1))
         FJ(I,2) = -I*(EXP(I*X2))
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SJESAM ( N, M, X, FTF )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
C
C  THE FOLLOWING APPROXIMATE VALUES WERE SUPPLIED BY 
C  MORE ET AL.
C     X(1) = 0.2578
C     X(2) = 0.2578
C     FTF = 124.362
C
C  FURTHER MINIMIZATION REVEALS:
C
      X(1) = 0.2578252
      X(2) = 0.2578252
      FTF = 124.3621
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE IJESAM ( N, M, X )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      X(1) = 0.3
      X(2) = 0.4
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FHELIX ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      X1 = X(1)
      X2 = X(2)
      X3 = X(3)
      IF (X1.EQ.0.) THEN
         WRITE (*,*) 'DIVISION BY ZERO IN FHELIX.'
         STOP
      END IF
      ONEM = -1.
      PI = ACOS(ONEM)
      QUO = X2/X1
      THETA = 0.5*ATAN(QUO)/PI
      IF (X1.LT.0.) THETA = THETA+0.5
      F(1) = 10*(X3-10*THETA)
      F(2) = 10*(SQRT(X1*X1+X2*X2)-1)
      F(3) = X3
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JHELIX ( M, N, X, FJ, LD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), FJ(LD,N)
C
      X1 = X(1)
      X2 = X(2)
      X3 = X(3)
C
      ONEM = -1.
      PI = ACOS(ONEM)
      A = X1*X1+X2*X2
      IF (A.EQ.0.) THEN
         WRITE (*,*) 'DIVISION BY ZERO IN JHELIX.'
         STOP
      END IF
      FPQ = 50/(PI*A)
      TR = 10/SQRT(A)
      FJ(1,1) = FPQ*X2
      FJ(1,2) = -FPQ*X1
      FJ(1,3) = 10
      FJ(2,1) = TR*X1
      FJ(2,2) = TR*X2
      FJ(2,3) = 0
      FJ(3,1) = 0
      FJ(3,2) = 0
      FJ(3,3) = 1
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SHELIX ( N, M, X, FTF )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      X(1) = 1
      X(2) = 0
      X(3) = 0
      FTF = 0
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE IHELIX ( N, M, X )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      X(1) = -1
      X(2) = 0
      X(3) = 0
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FBARD ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      DIMENSION Y(15)
      DATA Y / 0.14, 0.18, 0.22, 0.25, 0.29, 0.32, 0.35,
     >         0.39, 0.37, 0.58, 0.73, 0.96, 1.34, 2.10, 4.39 /
C
      X1 = X(1)
      X2 = X(2)
      X3 = X(3)
      DO 10,I=1,M
         UI = I
         VI = 16-I
         WI = MIN(UI,VI)
         DI = VI*X2 + WI*X3
         IF (DI.EQ.0.) THEN
            WRITE (*,*) 'DIVISION BY ZERO IN FBARD.'
            STOP
         END IF
         F(I) = X1 + (UI/DI) - Y(I)
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JBARD ( M, N, X, FJ, LD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), FJ(LD,N)
C
      X1 = X(1)
      X2 = X(2)
      X3 = X(3)
C
      DO 10,I=1,M
         UI = I
         VI = 16-I
         WI = MIN( UI, VI )
         DI = VI*X2 + WI*X3
         IF (DI.EQ.0.) THEN
            WRITE (*,*) 'DIVISION BY ZERO IN JBARD.'
            STOP
         END IF
         QI = -UI / (DI*DI)
         FJ(I,1) = 1
         FJ(I,2) = QI * VI
         FJ(I,3) = QI * WI
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SBARD ( N, M, X, FTF )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      FTF = 8.21487E-3
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE IBARD ( N, M, X )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      X(1) = 1
      X(2) = 1
      X(3) = 1
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FGAUSS ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      DIMENSION Y(15)
      DATA Y / 0.0009, 0.0044, 0.0175, 0.0540, 0.1295,
     >         0.2420, 0.3521, 0.3989, 0.3521, 0.2420,
     >         0.1295, 0.0540, 0.0175, 0.0044, 0.0009 /
C
      X1 = X(1)
      X2 = X(2)
      X3 = X(3)
      DO 10,I=1,M
         A = 8-I
         TI = A/2.
         F(I) = X1*EXP(-(X2*(TI-X3)**2)/2) - Y(I)
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JGAUSS ( M, N, X, FJ, LD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), FJ(LD,N)
C
      X1 = X(1)
      X2 = X(2)
      X3 = X(3)
C
      DO 10,I=1,M
         A = 8-I
         TI = A/2.
         T3 = TI - X3
         TT = (T3*T3)/2
         EI = EXP(-X2*TT)
         SI = X1*EI
         FJ(I,1) =  EI
         FJ(I,2) = -TT*SI
         FJ(I,3) =  X2*T3*SI
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SGAUSS ( N, M, X, FTF )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      FTF = 1.12793E-8
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE IGAUSS ( N, M, X )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      X(1) = 0.4
      X(2) = 1
      X(3) = 0
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FMEYER ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      DIMENSION Y(16)
      DATA Y / 34780., 28610., 23650., 19630., 
     >         16370., 13720., 11540.,  9744., 
     >          8261.,  7030.,  6005.,  5147.,
     >          4427.,  3820.,  3307.,  2872. /
C
      X1 = X(1)
      X2 = X(2)
      X3 = X(3)
      DO 10,I=1,M
         TI = 45+5*I
         DI = TI + X3
         EI = EXP(X2/DI)
         F(I) = (X1 * EI) - Y(I)
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JMEYER ( M, N, X, FJ, LD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), FJ(LD,N)
C
      X1 = X(1)
      X2 = X(2)
      X3 = X(3)
C
      DO 10,I=1,M
         TI = 45+5*I
         DI = TI + X3
         QI = 1. / DI
         EI = EXP(X2*QI)
         SI = X1*QI*EI
         FJ(I,1) =  EI
         FJ(I,2) =  SI
         FJ(I,3) = -X2*QI*SI
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SMEYER ( N, M, X, FTF )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      FTF = 87.9458
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE IMEYER ( N, M, X )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      X(1) = 0.02
      X(2) = 4000.
      X(3) = 250.
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FGULF ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      X1 = X(1)
      X2 = X(2)
      X3 = X(3)
      TWO = 2
      THREE = 3
      TWO3RD = TWO/THREE
      DO 10,I=1,M
         TI = 0.01*I
         YI = 25 + (-50*LOG(TI)) ** TWO3RD
         AI = YI - X2
         F(I) = EXP(-((ABS(AI)**X3)/X1)) - TI
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JGULF ( M, N, X, FJ, LD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), FJ(LD,N)
C
      X1 = X(1)
      X2 = X(2)
      X3 = X(3)
C
      TWO = 2
      THREE = 3
      TWO3RD = TWO/THREE
      IF (X1.EQ.0.) THEN
         WRITE (*,*) 'DIVISION BY ZERO IN JGULF.'
         STOP
      END IF
      X1INV = 1. / X1
      DO 210,I=1,M
         TI = 0.01*I
         YI = 25 + (-50*LOG(TI)) ** TWO3RD
         AI = YI - X2
         AV = ABS(AI)
         BI = AV ** X3
         CI = BI*X1INV
         EI = EXP(-CI)
         D1 =   CI * X1INV
         D2 =   X3 * X1INV * AV**(X3 - 1)
         D3 = - LOG(AV) * CI
         FJ(I,1) = D1 * EI
         IF (AI .GE. 0.)  FJ(I,2) =  D2 * EI
         IF (AI .LT. 0.)  FJ(I,2) = -D2 * EI
         FJ(I,3) = D3 * EI
 210  CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SGULF ( N, M, X, FTF )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      X(1) = 50
      X(2) = 25
      X(3) = 1.5
      FTF = 0
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE IGULF ( N, M, X )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      X(1) = 5
      X(2) = 2.5
      X(3) = 0.15
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FBOX ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      X1 = X(1)
      X2 = X(2)
      X3 = X(3)
      DO 10,I=1,M
         TI = 0.1*I
         E1 = EXP(-TI*X1)
         E2 = EXP(-TI*X2)
         T3 = EXP(-TI) - EXP(-TI*10)
         F(I) =  E1 - E2 - X3*T3
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JBOX ( M, N, X, FJ, LD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), FJ(LD,N)
C
      X1 = X(1)
      X2 = X(2)
      X3 = X(3)
C
      DO 10,I=1,M
         TI = 0.1*I
         E1 = EXP(-TI*X1)
         E2 = EXP(-TI*X2)
         T3 = EXP(-TI) - EXP(-TI*10)
         FJ(I,1) = -TI*E1
         FJ(I,2) = TI*E2
         FJ(I,3) = -T3
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SBOX ( N, M, X, FTF )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      X(1) = 1
      X(2) = 10
      X(3) = 1
      FTF = 0
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE IBOX ( N, M, X )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      X(1) =  0
      X(2) = 10
      X(3) = 20
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FPSING ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      NQRTR = N/4
      FIVE = 5
      TEN = 10
      RTFIVE = SQRT(FIVE)
      RTTEN  = SQRT(TEN)
      DO 10,I=1,NQRTR
         I4   = 4*I
         I4M1 = I4 - 1
         I4M2 = I4 - 2
         I4M3 = I4 - 3
         XI4   = X(I4)
         XI4M1 = X(I4M1)
         XI4M2 = X(I4M2)
         XI4M3 = X(I4M3)
         T1 = XI4M2 - 2*XI4M1
         T0 = XI4M3 - XI4
         F(I4M3) = XI4M3 + 10*XI4M2
         F(I4M2) = RTFIVE * (XI4M1 - XI4)
         F(I4M1) = T1 * T1
         F(I4  ) = RTTEN * T0 * T0
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JPSING ( M, N, X, FJ, LD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), FJ(LD,N)
C
      DO 20,I=1,N
         DO 20,J=1,M
20       FJ(J,I) = 0
C
      NQRTR = N/4
      FIVE = 5
      TEN = 10
      RTFIVE = SQRT(FIVE)
      RTTEN  = SQRT(TEN)
      RTTEN2 = 2 * RTTEN
      DO 10,I=1,NQRTR
          I4   = 4*I
          I4M1 = I4 - 1
          I4M2 = I4 - 2
          I4M3 = I4 - 3
          XI4   = X(I4)
          XI4M1 = X(I4M1)
          XI4M2 = X(I4M2)
          XI4M3 = X(I4M3)
          S1 = 2*(XI4M2 - 2*XI4M1)
          S0 = RTTEN2*(XI4M3 - XI4)
          FJ(I4M3,I4M3) =  1
          FJ(I4M3,I4M2) =  10
          FJ(I4M2,I4M1) =  RTFIVE
          FJ(I4M2,  I4) = -RTFIVE
          FJ(I4M1,I4M2) =  S1
          FJ(I4M1,I4M1) = -2*S1
          FJ(  I4,I4M3) =  S0
          FJ(  I4,  I4) = -S0
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SPSING ( N, M, X, FTF )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      DO 10,I=1,N
10       X(I) = 0
      FTF = 0
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE IPSING ( N, M, X )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      NQRTR = N/4
      DO 10,I=1,NQRTR
         I4 = 4*I
         X(I4-3) =  3
         X(I4-2) = -1
         X(I4-1) =  0
         X(I4  ) =  1
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FWOOD ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      X1 = X(1)
      X2 = X(2)
      X3 = X(3)
      X4 = X(4)
C
      TEN = 10
      ANINE = 90
      RT10    = SQRT(TEN)
      R10INV  = 1. / RT10
      RT90    = SQRT(ANINE)
      F(1) = 10*(X2 - X1*X1)
      F(2) = 1 - X1
      F(3) = RT90*(X4 - X3*X3)
      F(4) = 1 - X3
      F(5) = RT10*(X2 + X4 - 2)
      F(6) = R10INV*(X2 - X4)
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JWOOD ( M, N, X, FJ, LD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), FJ(LD,N)
C
      X1 = X(1)
      X2 = X(2)
      X3 = X(3)
      X4 = X(4)
C
      TEN = 10
      ANINE = 90
      RT10    = SQRT(TEN)
      R10INV  = 1. / RT10
      RT90    = SQRT(ANINE)
      FJ( 1, 1) = -20*X1
      FJ( 1, 2) =  10
      FJ( 1, 3) =  0
      FJ( 1, 4) =  0
      FJ( 2, 1) = -1
      FJ( 2, 2) =  0
      FJ( 2, 3) =  0
      FJ( 2, 4) =  0
      FJ( 3, 1) =  0
      FJ( 3, 2) =  0
      FJ( 3, 3) = -2*RT90*X3
      FJ( 3, 4) =  RT90
      FJ( 4, 1) =  0
      FJ( 4, 2) =  0
      FJ( 4, 3) = -1
      FJ( 4, 4) =  0
      FJ( 5, 1) =  0
      FJ( 5, 2) =  RT10
      FJ( 5, 3) =  0
      FJ( 5, 4) =  RT10
      FJ( 6, 1) =  0
      FJ( 6, 2) =  R10INV
      FJ( 6, 3) =  0
      FJ( 6, 4) = -R10INV
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SWOOD ( N, M, X, FTF )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      X(1) =  1
      X(2) =  1
      X(3) =  1
      X(4) =  1
      FTF = 0
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE IWOOD ( N, M, X )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      X(1) = -3
      X(2) = -1
      X(3) = -3
      X(4) = -1
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FKOWOS ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      DIMENSION U(11), Y(11)
      DATA Y / 0.1957, 0.1947, 0.1735, 0.1600,
     >         0.0844, 0.0627, 0.0456, 0.0342,
     >         0.0323, 0.0235, 0.0246 /
      DATA U / 4.0000, 2.0000, 1.0000, 0.5000,
     >         0.2500, 0.1670, 0.1250, 0.1000,
     >         0.0833, 0.0714, 0.0625 /
C
      X1 = X(1)
      X2 = X(2)
      X3 = X(3)
      X4 = X(4)
      DO 10,I=1,M
         UI = U(I)
         T2 = UI*(UI + X2)
         DI = UI*(UI + X3) + X4
         F(I) = (X1*T2)/DI - Y(I)
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JKOWOS ( M, N, X, FJ, LD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), FJ(LD,N)
C
      DIMENSION U(11)
      DATA U / 4.0000, 2.0000, 1.0000, 0.5000,
     >         0.2500, 0.1670, 0.1250, 0.1000,
     >         0.0833, 0.0714, 0.0625 /
C
      X1 = X(1)
      X2 = X(2)
      X3 = X(3)
      X4 = X(4)
C
      DO 10,I=1,M
         UI = U(I)
         T2 = UI*(UI + X2)
         DI = UI*(UI + X3) + X4
         QI = 1. / DI
         R  =  T2*QI
         S  =  X1*QI
         V  = -R*S
         FJ(I,1) = R
         FJ(I,2) = S*UI
         FJ(I,3) = V*UI
         FJ(I,4) = V
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SKOWOS ( N, M, X, FTF )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      FTF = 3.07505E-4
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE IKOWOS ( N, M, X )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      X(1) = 0.25
      X(2) = 0.39
      X(3) = 0.415
      X(4) = 0.39
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FBRDEN ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      X1 = X(1)
      X2 = X(2)
      X3 = X(3)
      X4 = X(4)
      DO 10,I=1,M
         TI   = 0.2*I
         EI   = EXP(TI)
         SI   = SIN(TI)
         CI   = COS(TI)
         F(I) = (X1 + TI*X2 - EI)**2 + (X3 + X4*SI - CI)**2
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JBRDEN ( M, N, X, FJ, LD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), FJ(LD,N)
C
      X1 = X(1)
      X2 = X(2)
      X3 = X(3)
      X4 = X(4)
C
      DO 10,I=1,M
         TI   = 0.2*I
         EI = EXP(TI)
         SI = SIN(TI)
         CI = COS(TI)
         F1 = 2*(X1 + TI*X2 - EI)
         F3 = 2*(X3 + X4*SI - CI)
         FJ( I, 1) = F1
         FJ( I, 2) = F1 * TI
         FJ( I, 3) = F3
         FJ( I, 4) = F3 * SI
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SBRDEN ( N, M, X, FTF )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      FTF = 8.58222E+4
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE IBRDEN ( N, M, X )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      X(1) = 25
      X(2) =  5
      X(3) = -5
      X(4) = -1
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FOSB1 ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      DIMENSION Y(33)
      DATA Y / 0.844, 0.908, 0.932, 0.936, 0.925, 0.908,
     >         0.881, 0.850, 0.818, 0.784, 0.751, 0.718,
     >         0.685, 0.658, 0.628, 0.603, 0.580, 0.558,
     >         0.538, 0.522, 0.506, 0.490, 0.478, 0.467,
     >         0.457, 0.448, 0.438, 0.431, 0.424, 0.420,
     >         0.414, 0.411, 0.406 /
C
      X1 = X(1)
      X2 = X(2)
      X3 = X(3)
      X4 = X(4)
      X5 = X(5)
      IM1 = 0
      DO 10,I=1,M
         TI   =  10*IM1
         E4   =  EXP(-TI*X4)
         E5   =  EXP(-TI*X5)
         F(I) = (X1 + X2*E4 + X3*E5) - Y(I)
         IM1  =  I
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JOSB1 ( M, N, X, FJ, LD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), FJ(LD,N)
C
      X1 = X(1)
      X2 = X(2)
      X3 = X(3)
      X4 = X(4)
      X5 = X(5)
C
      IM1 = 0
      DO 10,I=1,M
         TI = 10*IM1
         E4 = EXP(-TI*X4)
         E5 = EXP(-TI*X5)
         FJ( I, 1) = 1
         FJ( I, 2) =  E4
         FJ( I, 3) =  E5
         FJ( I, 4) = -TI*X2*E4
         FJ( I, 5) = -TI*X3*E5
         IM1 = I
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SOSB1 ( N, M, X, FTF )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      X(1) =  0.3754
      X(2) =  1.9358
      X(3) = -1.4647
      X(4) =  0.01287
      X(5) =  0.02212
      FTF = 5.46489E-5
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE IOSB1 ( N, M, X )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      X(1) =  0.5
      X(2) =  1.5
      X(3) = -1.0
      X(4) =  0.01
      X(5) =  0.02
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FBIGGS ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      X1 = X(1)
      X2 = X(2)
      X3 = X(3)
      X4 = X(4)
      X5 = X(5)
      X6 = X(6)
      DO 10,I=1,M
         TI = 0.1*I
         YP = EXP(-TI) + 3*EXP(-4*TI)
         YM = 5*EXP(-10*TI)
         E1 = EXP(-TI*X1)
         E2 = EXP(-TI*X2)
         E5 = EXP(-TI*X5)
         F(I) = (X3*E1 + X6*E5  + YM) - (X4*E2 + YP)
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JBIGGS ( M, N, X, FJ, LD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), FJ(LD,N)
C
      X1 = X(1)
      X2 = X(2)
      X3 = X(3)
      X4 = X(4)
      X5 = X(5)
      X6 = X(6)
C
      DO 10,I=1,M
         TI = 0.1*I
         E1 = EXP(-TI*X1)
         E2 = EXP(-TI*X2)
         E5 = EXP(-TI*X5)
         FJ( I, 1) = -TI*X3*E1
         FJ( I, 2) =  TI*X4*E2
         FJ( I, 3) =  E1
         FJ( I, 4) = -E2
         FJ( I, 5) = -TI*X6*E5
         FJ( I, 6) =  E5
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SBIGGS ( N, M, X, FTF )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      X(1) =  1
      X(2) =  10
      X(3) =  1
      X(4) =  5
      X(5) =  4
      X(6) =  3
      FTF = 0
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE IBIGGS ( N, M, X )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      X(1) = 1
      X(2) = 2
      X(3) = 1
      X(4) = 1
      X(5) = 1
      X(6) = 1
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FOSB2 ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      DIMENSION Y(65)
      DATA Y / 1.366, 1.191, 1.112, 1.013, 0.991, 0.885, 0.831,
     >         0.847, 0.786, 0.725, 0.746, 0.679, 0.608, 0.655, 
     >         0.615, 0.606, 0.602, 0.626, 0.651, 0.724, 0.649, 
     >         0.649, 0.694, 0.644, 0.624, 0.661, 0.612, 0.558, 
     >         0.533, 0.495, 0.500, 0.423, 0.395, 0.375, 0.372, 
     >         0.391, 0.396, 0.405, 0.428, 0.429, 0.523, 0.562, 
     >         0.607, 0.653, 0.672, 0.708, 0.633, 0.668, 0.645, 
     >         0.632, 0.591, 0.559, 0.597, 0.625, 0.739, 0.710, 
     >         0.729, 0.720, 0.636, 0.581, 0.428, 0.292, 0.162, 
     >         0.098, 0.054 /
C
      X1 = X(1)
      X2 = X(2)
      X3 = X(3)
      X4 = X(4)
      X5 = X(5)
      X6 = X(6)
      X7 = X(7)
      X8 = X(8)
      X9 = X(9)
      X10 = X(10)
      X11 = X(11)
      IM1 = 0
      DO 10,I=1,M
         TI  = 0.1*IM1
         T09 = TI - X9
         T10 = TI - X10
         T11 = TI - X11
         S09 = T09 * T09
         S10 = T10 * T10
         S11 = T11 * T11
         E1  = EXP(-TI*X5)
         E2  = EXP(-S09*X6)
         E3  = EXP(-S10*X7)
         E4  = EXP(-S11*X8)
         F(I) = (X1*E1 + X2*E2 + X3*E3 + X4*E4) - Y(I)
         IM1 = I
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JOSB2 ( M, N, X, FJ, LD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), FJ(LD,N)
C
      X1 = X(1)
      X2 = X(2)
      X3 = X(3)
      X4 = X(4)
      X5 = X(5)
      X6 = X(6)
      X7 = X(7)
      X8 = X(8)
      X9 = X(9)
      X10 = X(10)
      X11 = X(11)
C
      IM1 = 0
      DO 10,I=1,M
         TI  = 0.1*IM1
         T09 = TI - X9
         T10 = TI - X10
         T11 = TI - X11
         S09 = T09 * T09
         S10 = T10 * T10
         S11 = T11 * T11
         E1  = EXP(-TI*X5)
         E2  = EXP(-S09*X6)
         E3  = EXP(-S10*X7)
         E4  = EXP(-S11*X8)
         R2  = X2*E2
         R3  = X3*E3
         R4  = X4*E4
         FJ( I, 1) = E1
         FJ( I, 2) = E2
         FJ( I, 3) = E3
         FJ( I, 4) = E4
         FJ( I, 5) = -TI*X1*E1
         FJ( I, 6) = -S09*R2
         FJ( I, 7) = -S10*R3
         FJ( I, 8) = -S11*R4
         FJ( I, 9) =  2*T09*X6*R2
         FJ( I,10) =  2*T10*X7*R3
         FJ( I,11) =  2*T11*X8*R4
         IM1 = I
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SOSB2 ( N, M, X, FTF )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      X( 1) =  1.3100
      X( 2) =  0.4315
      X( 3) =  0.6336
      X( 4) =  0.5993
      X( 5) =  0.7539
      X( 6) =  0.9056
      X( 7) =  1.3651
      X( 8) =  4.8248
      X( 9) =  2.3988
      X(10) =  4.5689
      X(11) =  5.6754
      FTF = 4.01683E-2
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE IOSB2 ( N, M, X )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      X( 1) =  1.3
      X( 2) =  0.65
      X( 3) =  0.65
      X( 4) =  0.7
      X( 5) =  0.6
      X( 6) =  3.
      X( 7) =  5.
      X( 8) =  7.
      X( 9) =  2.
      X(10) =  4.5
      X(11) =  5.5
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FWATSO ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      N1   = N  - 1
      N2   = N1 - 1
      X1 = X(1)
      R2 = X(N)
      R1 = N1*R2
      TWNTY9 = 29.
      DO 20,I=1,29
         TI  = I / TWNTY9
         S1  = R1
         S2  = R2
         NJ  = N1
         NJ1 = N2
         DO 10,J=2,N1
            XNJ = X(NJ)
            S1  = NJ1*XNJ + TI*S1
            S2  = XNJ + TI*S2
            NJ  = NJ1
            NJ1 = NJ1 - 1
10       CONTINUE
         S2   = X1 + TI*S2
         F(I) = S1 - S2*S2 - 1
20    CONTINUE
C
      F(30) = X1
      F(31) = X(2) - X1*X1 - 1
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JWATSO ( M, N, X, FJ, LD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), FJ(LD,N)
C
      N1   = N  - 1
      R2 = X(N)
      TWNTY9 = 29.
      DO 20,I=1,29
         TI = I / TWNTY9
         S2 = R2
         NJ = N1
         DO 10,J=1,N1
            S2 = X(NJ) + TI*S2
            NJ = NJ - 1
10       CONTINUE
         T2      =  2*S2
         FJ(I,1) = -T2
         T2I     =  T2*TI
         FJ(I,2) =  1 - T2I
         JM1     =  2
         TIJM2   =  TI
         DO 20,J=3,N
            FJ(I,J) = (JM1 - T2I) * TIJM2
            JM1     = J
            TIJM2   = TIJM2 * TI
20    CONTINUE
C
      FJ(30,1) = 1
      FJ(31,1) = -2*X(1)
      FJ(30,2) = 0
      FJ(31,2) = 1
C
      DO 30,J=3,N
        FJ(30,J) = 0
        FJ(31,J) = 0
30    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SWATSO ( N, M, X, FTF )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      FTF = 2.48631E-20
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE IWATSO ( N, M, X )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      DO 10,I=1,N
10       X(I) = 0
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FROSEX ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      PARAMETER ( COEFF = 10. )
C
      NEVEN = N/2
      DO 10,I=1,NEVEN
         I2 = 2*I
         I1 = I2-1
         X2 = X(I2)
         X1 = X(I1)
         F(I2) = 1.0-X1
         F(I1) = COEFF*(X2-X1*X1)
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JROSEX ( M, N, X, FJ, LD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), FJ(LD,N)
C
      PARAMETER ( COEFF = 10. )
C
      NEVEN = N/2
      DO 20,I=1,N
         DO 20,J=1,M
20       FJ(J,I) = 0
C
      DO 10,I=1,NEVEN
         I2 = 2*I
         I1 = I2-1
         X2 = X(I2)
         X1 = X(I1)
         FJ(I1,I1) = -2*COEFF*X1
         FJ(I1,I2) = COEFF
         FJ(I2,I1) = -1
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SROSEX ( N, M, X, FTF )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      DO 30,I=1,N
         X(I) = 1
30    CONTINUE
      FTF = 0
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE IROSEX ( N, M, X )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      NEVEN = N/2
      DO 21,I=1,NEVEN
         I2 = 2*I
         X(I2-1) = -1.2
         X(I2) = 1.0
21    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FPSINX ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      NQRTR = N/4
      FIVE = 5
      TEN = 10
      RTFIVE = SQRT(FIVE)
      RTTEN  = SQRT(TEN)
      DO 10,I=1,NQRTR
         I4   = 4*I
         I4M1 = I4 - 1
         I4M2 = I4 - 2
         I4M3 = I4 - 3
         XI4   = X(I4)
         XI4M1 = X(I4M1)
         XI4M2 = X(I4M2)
         XI4M3 = X(I4M3)
         T1 = XI4M2 - 2*XI4M1
         T0 = XI4M3 - XI4
         F(I4M3) = XI4M3 + 10*XI4M2
         F(I4M2) = RTFIVE * (XI4M1 - XI4)
         F(I4M1) = T1 * T1
         F(I4  ) = RTTEN * T0 * T0
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JPSINX ( M, N, X, FJ, LD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), FJ(LD,N)
C
      DO 20,I=1,N
         DO 20,J=1,M
20       FJ(J,I) = 0
C
      NQRTR = N/4
      FIVE = 5
      TEN = 10
      RTFIVE = SQRT(FIVE)
      RTTEN  = SQRT(TEN)
      RTTEN2 = 2 * RTTEN
      DO 10,I=1,NQRTR
          I4   = 4*I
          I4M1 = I4 - 1
          I4M2 = I4 - 2
          I4M3 = I4 - 3
          XI4   = X(I4)
          XI4M1 = X(I4M1)
          XI4M2 = X(I4M2)
          XI4M3 = X(I4M3)
          S1 = 2*(XI4M2 - 2*XI4M1)
          S0 = RTTEN2*(XI4M3 - XI4)
          FJ(I4M3,I4M3) =  1
          FJ(I4M3,I4M2) =  10
          FJ(I4M2,I4M1) =  RTFIVE
          FJ(I4M2,  I4) = -RTFIVE
          FJ(I4M1,I4M2) =  S1
          FJ(I4M1,I4M1) = -2*S1
          FJ(  I4,I4M3) =  S0
          FJ(  I4,  I4) = -S0
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SPSINX ( N, M, X, FTF )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      DO 10,I=1,N
10       X(I) = 0
      FTF = 0
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE IPSINX ( N, M, X )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      NQRTR = N/4
      DO 10,I=1,NQRTR
         I4 = 4*I
         X(I4-3) =  3
         X(I4-2) = -1
         X(I4-1) =  0
         X(I4  ) =  1
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FPEN1 ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      A      = 1.E-5
      A2     = SQRT(A)
      SUM = -0.25
      DO 10,I=1,N
         XI   = X(I)
         SUM  = SUM + XI*XI
         F(I) = A2*(XI - 1)
10    CONTINUE
      F(N+1) = SUM
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JPEN1 ( M, N, X, FJ, LD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), FJ(LD,N)
C
      DO 20,I=1,N
         DO 20,J=1,M
20       FJ(J,I) = 0
C
      A      = 1.E-5
      A2     = SQRT(A)
      DO 10,J=1,N
         FJ(J,J) = A2
         FJ(M,J) = 2*X(J)
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SPEN1 ( N, M, X, FTF )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      FTF = 2.24997E-5
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE IPEN1 ( N, M, X )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      DO 21,J=1,N
         X(J) = J
21    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FPEN2 ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      SCALE = 0.1
      A  = 1.E-5
      AR = SQRT(A)
      D0 = AR*EXP(-SCALE)
      X1 = X(1)
      SUM  = N*(X1*X1)
      F(1) = X1 - 0.2
      SJ   = AR*EXP(SCALE)
      TJ   = AR*EXP(X1*SCALE)
      JM1  = 1
      DO 10,J=2,N
         SJM1     = SJ
         SJ       = AR*EXP(J*SCALE)
         XJ       = X(J)
         TJM1     = TJ
         TJ       = AR*EXP(XJ*SCALE)
         F(J)     = (TJ + TJM1) - (SJ + SJM1)
         F(N+JM1) = TJ - D0
         SUM      = SUM + (N-JM1)*(XJ*XJ)
         JM1      = J
10    CONTINUE
      F(M) = SUM - 1
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JPEN2 ( M, N, X, FJ, LD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), FJ(LD,N)
C
      DO 10,I=1,N
         DO 10,J=1,M
10       FJ(J,I) = 0
C
      SCALE = 0.1
      A  = 1.E-5
      AR = SQRT(A)
      AP = AR*SCALE
      X1 = X(1)
      FJ(1,1) = 1
      FJ(M,1) = 2*N*X1
      UJ      = AP*EXP(X1*SCALE)
      JM1     = 1
      DO 20,J=2,N
        XJ   = X(J)
        UJM1 = UJ
        UJ   = AP*EXP(XJ*SCALE)
        FJ(J    , JM1) = UJM1
        FJ(J    , J  ) = UJ
        FJ(N+JM1, J  ) = UJ
        FJ(M    , J  ) = 2*(N-JM1)*XJ
        JM1 = J
20    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SPEN2 ( N, M, X, FTF )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      FTF = 9.37629E-6
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE IPEN2 ( N, M, X )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      DO 21,J=1,N
         X(J) = 0.5
21    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FVARDI ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      SUM = 0
      DO 10,I=1,N
         XIM1 = X(I) - 1
         SUM  = SUM + I*XIM1
         F(I) = XIM1
10    CONTINUE
      F(N+1) = SUM
      F(N+2) = SUM*SUM
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JVARDI ( M, N, X, FJ, LD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), FJ(LD,N)
C
      DO 20,I=1,N
         DO 20,J=1,M
20       FJ(J,I) = 0
C
      SUM = 0
      DO 210 J = 1, N
        SUM = SUM + J*(X(J) - 1)
 210  CONTINUE
C
      DO 22,J=1,N
         DJ        = J
         FJ(J  ,J) = 1
         FJ(N+1,J) = DJ
         FJ(N+2,J) = 2*SUM*DJ
22    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SVARDI ( N, M, X, FTF )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      DO 31,I=1,N
         X(I) = 1
31    CONTINUE
      FTF = 0
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE IVARDI ( N, M, X )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      DN = N
      DO 21,J=1,N
         X(J) = 1 - J/DN
21    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FTRIG ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      SUM = 0
      DO 10,I=1,N
         XI   = X(I)
         CXI  = COS(XI)
         SUM  = SUM + CXI
         F(I) = N + I*(1 - CXI) - SIN(XI)
10    CONTINUE
C
      DO 20,I=1,N
        F(I) = F(I) - SUM
20    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JTRIG ( M, N, X, FJ, LD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), FJ(LD,N)
C
      DO 20,J=1,N
         XJ  = X(J)
         SXJ = SIN(XJ)
         DO 10,I=1,N
            FJ( I, J) = SXJ
10       CONTINUE
         FJ(J, J) =  (J+1)*SXJ - COS(XJ)
20    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE STRIG ( N, M, X, FTF )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      FTF = 0
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE ITRIG ( N, M, X )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      ONE = 1
      RN = N
      DIV = ONE/RN
      DO 10,I=1,N
10       X(I) = DIV
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FBALMO ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      SUM = 0
      PRD =  1
      DO 10,I=1,N
         XI  = X(I)
         SUM = SUM + XI
         PRD = PRD * XI
         F(I) = XI - (N+1)
10    CONTINUE
C
      DO 20,I=1,N-1
         F(I) = F(I) + SUM
20    CONTINUE
      F(N) = PRD - 1
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JBALMO ( M, N, X, FJ, LD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), FJ(LD,N)
C
      DO 20,J=1,N
         DO 10,I=1,N-1
            FJ( I, J) = 1
10       CONTINUE
         FJ(    J, J) = 2
20    CONTINUE
C
      DO 40,J=1,N
         T = 1
         DO 30,I=1,N
            IF (I .NE. J)  T = T * X(I)
30       CONTINUE
         FJ( N, J) = T
40    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SBALMO ( N, M, X, FTF )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      DO 10,I=1,N
10       X(I) = 1
      FTF = 0
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE IBALMO ( N, M, X )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      DO 10,I=1,N
10       X(I) = 0.5
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FDBP ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      I  =   1
      XI = X(1)
      ONE = 1
      RN1 = N+1
      H = ONE / RN1
      DO 10,IP1=2,N+1
         IF (I .NE. N)  XIP1 = X(IP1)
         T = 2*XI + (H*H*(XI + I*H + 1)**3)/2
         IF (I .NE. 1)  T = T - XIM1
         IF (I .NE. N)  T = T - XIP1
         F(I) = T
         I    = IP1
         XIM1 = XI
         XI   = XIP1
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JDBP ( M, N, X, FJ, LD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), FJ(LD,N)
C
      DO 20,I=1,N
         DO 20,J=1,M
20       FJ(J,I) = 0
C
      ONE = 1
      RN1 = N+1
      H = ONE / RN1
      I = 1
      DO 10,IP1=2,N+1
         FJ(I,I) = 2 + (3*H*H*(X(I) + I*H + 1)**2)/2
         IF (I .NE. 1)  FJ(I,IM1) = -1
         IF (I .NE. N)  FJ(I,IP1) = -1
         IM1 = I
         I   = IP1
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SDBP ( N, M, X, FTF )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      FTF = 0
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE IDBP ( N, M, X )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      ONE = 1
      RN1 = N+1
      H = ONE / RN1
      DO 21,J=1,N
         TJ   = J*H
         X(J) = TJ*(TJ-1)
21    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FDIE ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      DO 20,I=1,N
20       F(I) = X(I)
C
      ONE = 1
      RN1 = N+1
      H      = ONE / RN1
      H2     = 0.5*H
      DO 10,J=1,N
         TJ = J*H
         OJ = 1 - TJ
         CJ = H2*(X(J) + TJ + 1)**3
         DO 10,I=1,N
            TI = I*H
            OI = 1 - TI
            IF (J .LE. I)  F(I) = F(I) + OI*TJ*CJ
            IF (J .GT. I)  F(I) = F(I) + TI*OJ*CJ
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JDIE ( M, N, X, FJ, LD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), FJ(LD,N)
C
      ONE = 1
      RN1 = N+1
      H      = ONE / RN1
      H2     = 0.5*H
C
      DO 10,J=1,N
         TJ = J*H
         OJ = 1 - TJ
         SJ = 3*H2*(X(J) + TJ + 1)**2
         FJ(J,J) =  1 + OJ*TJ*SJ
         DO 10 I = 1, N
            TI = I*H
            OI = 1 - TI
            IF (J .LT. I)  FJ(I,J) =  OI*TJ*SJ
            IF (J .GT. I)  FJ(I,J) =  TI*OJ*SJ
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SDIE ( N, M, X, FTF )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      FTF = 0
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE IDIE ( N, M, X )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      ONE = 1
      RN1 = N+1
      H      = ONE / RN1
C
      DO 21,J=1,N
         TJ   = J*H
         X(J) = TJ*(TJ-1)
21    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FBTRI ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      I = 1
      XI = X(1)
      DO 10,IP1=2,N+1
         IF (I .LT. N)  XIP1 = X(IP1)
         F(I) = (3 - 2*XI)*XI + 1
         IF (I .GT. 1)  F(I) = F(I) - XIM1
         IF (I .LT. N)  F(I) = F(I) - 2*XIP1
         I    = IP1
         XIM1 = XI
         XI   = XIP1
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JBTRI ( M, N, X, FJ, LD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), FJ(LD,N)
C
      DO 10,I=1,N
         DO 10,J=1,M
10       FJ(J,I) = 0
C
      I = 1
      DO 20,IP1=2,N+1
         XI      = X(I)
         FJ(I,I) = 3 - 4*XI
         IF (I .GT. 1)  FJ(I,IM1) = -1
         IF (I .LT. N)  FJ(I,IP1) = -2
         IM1 = I
         I   = IP1
20    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SBTRI ( N, M, X, FTF )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      FTF = 0
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE IBTRI ( N, M, X )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      DO 10,I=1,N
10       X(I) = -1
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FBBAND ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      ILBW   = 5
      IUBW   = 1
      DO 10,I=1,N
         XI   = X(I)
         F(I) = XI*(2 + 5*XI*XI) + 1
         J1   = MAX( 1, I-ILBW)
         J2   = MIN( N, I+IUBW)
         DO 10,J=J1,J2
            XJ = X(J)
            IF (J .NE. I)  F(I) = F(I) - XJ*(1 + XJ)
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JBBAND ( M, N, X, FJ, LD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), FJ(LD,N)
C
      DO 10,I=1,N
         DO 10,J=1,M
10       FJ(J,I) = 0
C
      ILBW   = 5
      IUBW   = 1
      DO 20,I=1,N
         XI      = X(I)
         FJ(I,I) = 2 + 15*XI*XI
         J1      = MAX( 1, I-ILBW)
         J2      = MIN( N, I+IUBW)
         DO 20,J=J1,J2
            IF (J .NE. I)  FJ(I,J) = -(1 + 2*X(J))
20    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SBBAND ( N, M, X, FTF )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      FTF = 0
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE IBBAND ( N, M, X )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      DO 10,I=1,N
10       X(I) = -1
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FLINE ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      TWO = 2
      RM = M
      DNFI2  = TWO / RM
      SUM = 0
      DO 10,J=1,N
         SUM = SUM + X(J)
10    CONTINUE
C
      TWO = 2
      RM = M
      DNFI2  = TWO / RM
      DO 20,I=1,M
         IF (I .LE. N)  F(I) = X(I) - DNFI2*SUM - 1
         IF (I .GT. N)  F(I) =      - DNFI2*SUM - 1
20    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JLINE ( M, N, X, FJ, LD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), FJ(LD,N)
C
      TWO = 2
      RM = M
      DNFI2  = TWO / RM
      DO 10,I=1,M
         DO 10,J=1,N
            IF (I .LE. N)  FJ(I,J) = -DNFI2
            IF (I .LE. N)  FJ(I,I) = 1 - DNFI2
            IF (I .GT. N)  FJ(I,J) = -DNFI2
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SLINE ( N, M, X, FTF )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      DO 10,I=1,N
10       X(I) = -1
      FTF = M - N
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE ILINE ( N, M, X )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      DO 10,I=1,N
10       X(I) = 1
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FLINE1 ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      SUM = 0
      DO 10,J=1,N
         SUM = SUM + X(J)*J
10    CONTINUE
C
      DO 20,I=1,M
         F(I) = I*SUM - 1
20    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JLINE1 ( M, N, X, FJ, LD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), FJ(LD,N)
C
      DO 10,I=1,M
         DI = I
         DO 10,J=1,N
            FJ(I,J) = DI*J
10    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SLINE1 ( N, M, X, FTF )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      R1 = M*(M-1)
      R2 = 2*(2*M+1)
      FTF = R1/R2
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE ILINE1 ( N, M, X )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      DO 10,I=1,N
10       X(I) = 1
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FLINE0 ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      SUM = 0
      DO 10,J=2,N-1
         SUM = SUM + X(J)*J
10    CONTINUE
C
      F(1) = -1
      DO 20,I=2,M-1
         F(I) = (I-1)*SUM - 1
20    CONTINUE
      F(M) = -1
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JLINE0 ( M, N, X, FJ, LD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), FJ(LD,N)
C
      DO 10,I=1,N
         DO 10,J=1,M
10       FJ(J,I) = 0
C
      DO 20,I=2,M-1
         DI = I-1
         DO 20,J=2,N-1
            FJ(I,J) = DI*J
20    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SLINE0 ( N, M, X, FTF )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      R1 = M*M+3*M-6
      R2 = 2*(2*M-3)
      FTF = R1/R2
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE ILINE0 ( N, M, X )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      DO 10,I=1,N
10       X(I) = 1
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE FCHEBY ( M, N, X, F )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), F(M)
C
      DO 80,I=1,M
80       F(I) = 0
C
      ONE = 1
      M2     = M/2
      COEFF  = ONE / N
      DO 10,I=1,M2
         I2 = 2*I
         RD = (I2*I2) - 1
         F(I2) = ONE / RD
10    CONTINUE
C
      DO 25,J=1,N
         T0 = 1
         T1 = 2 * X(J) - 1
         TJ = T1
         F(1) = F(1) + COEFF*T1
         DO 20,I=2,M
            T = 2*TJ*T1 - T0
            F(I) = F(I) + COEFF*T
            T0 = T1
            T1 = T
20       CONTINUE
25    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE JCHEBY ( M, N, X, FJ, LD )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N), FJ(LD,N)
C
      ONE = 1
      COEFF  = ONE / N
      DO 25,J=1,N
         T0 = 1
         S0 = 0
         S1 = 2
         T1 = 2 * X(J) - 1
         TJ = T1
         FJ( 1, J) = COEFF*S1
         DO 20,I=2,M
            U  = 2 * TJ
            T  = U*T1 - T0
            S  = 4*T1 + U*S1 - S0
            FJ( I, J) = COEFF*S
            T0 = T1
            T1 = T
            S0 = S1
            S1 = S
20       CONTINUE
25    CONTINUE
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE SCHEBY ( N, M, X, FTF )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      FTF = 4.77271E-3
C
      END
C
C  ---------------------------------------------------------------------
C
      SUBROUTINE ICHEBY ( N, M, X )
******IMPLICIT DOUBLE PRECISION (A-H,O-Z)
      DIMENSION X(N)
C
      ONE = 1
      DN1 = ONE / (N+1)
      DO 21,I=1,N
         X(I) = I * DN1
21    CONTINUE
C
      END
